import { AbstractBatchOperation, AbstractLevel } from "abstract-level";
export type LevelBatchOptions = {
    interval: number;
    onError?: (error: any) => void;
};
export type LazyLevelOptions = {
    batch?: LevelBatchOptions | boolean;
};
export default class LazyLevel {
    _store: AbstractLevel<any, any, any>;
    _interval: any;
    _txQueue?: AbstractBatchOperation<AbstractLevel<any, string, Uint8Array>, string, Uint8Array>[];
    _tempStore?: Map<string, Uint8Array>;
    _tempDeleted?: Set<string>;
    _txPromise?: Promise<void>;
    _batchOptions?: {
        interval: number;
        onError?: (e: any) => void;
    };
    constructor(store: AbstractLevel<any, any, any>, opts?: LazyLevelOptions);
    get status(): "opening" | "open" | "closing" | "closed";
    idle(): Promise<void>;
    close(): Promise<void>;
    open(): Promise<void | this>;
    get(key: string): Promise<Uint8Array | undefined>;
    getByPrefix(prefix: string): Promise<Uint8Array[]>;
    deleteByPrefix(prefix: string): Promise<void>;
    set(key: string, value: Uint8Array): Promise<void> | undefined;
    del(key: string): Promise<void>;
    delAll(keys: string[]): Promise<void>;
}
